#include <Reg51.h>
#define D1 255

sbit tDQ    = P2^0;
sbit tCLK   = P2^1;
sbit tRST   = P2^2;

unsigned char data tmpbuffer;
unsigned char data tmpsign;

void delay1(void);

void main(void) {

  void send1620cmd(void);
  void read1620cmd(void);
  
  // initialize DS1620 as 3 wires , continues mode.  
  P2 = 0x00;
  tCLK = 0;
  tmpbuffer = 0x0C;  // send write configuration
  send1620cmd();
  tmpbuffer = 0x02;  // set CPU bit = 1, 3 wires mode
  send1620cmd();
  tRST = 0;	     // set DS1620 inactive
  delay1();
  tmpbuffer = 0xEE;  // send start conversion mode
  send1620cmd();
  tRST = 0;	     // set DS1620 inactive
  delay1();
  // initialize DS1620 as 3 wires , continues mode.  
	
  TMOD	= 0x20; // SET MODE2 FOR TIMER1  00100000B
  PCON	= 0x00; // SET PCON.SMOD = 0     00000000B
  SCON	= 0x42;	// SCON MODE 1 FOR UART, REN=0	01000010B
  TH1	= 0xFD; // 38400bps TIMER1 22.1MHZ RESTART VALUE   
  TL1	= 0xFD; // AUTO RELOAD TL1 IF TL1=00H
  TR1	= 1;	// TCON.TR1 = 1 , TIMER1 START NOW  


  while (1) { //BLANK LED
    delay1();
    tmpbuffer = 0xAA;  // send read temperature command
    send1620cmd();
    read1620cmd();
    
    TI = 0;		// CLEAR LAST TX INTERRUPT 
    SBUF = tmpbuffer;
    while (~TI) { }  // WAIT UNTIL TI BIT IS SET - TRANSFER FINISHED

  }
}


void send1620cmd() {
  unsigned char data i,b=0x01;
  tRST = 1;                // set DS1620 enable
  delay1();
  for(i=0;i<8;i++) {
    tCLK = 0;                 // SETUP FOR CLOCK PLUSE
    tDQ = ( tmpbuffer & b );  // MOVE a BIT TO DQ 
    tCLK = 1;                 // FINISH THE CLOCK PULSE 
    b = (b<<1);
  }
}

void read1620cmd() {
  unsigned char data i,b=1;
  tmpbuffer = 0;
  delay1();
  for(i=0;i<8;i++) {
    tCLK=0;        // set CLK low
    if (tDQ) tmpbuffer|=b;   // READ A Bit
    tCLK=1;        // set CLK high
    b = (b<<1);
  }
  tCLK=0;          // set CLK low
  tmpsign = tDQ;   // READ sign
  tCLK=1;          // set CLK high  
  tRST=0;          // set RST DS1620 = disable
  delay1();
}

void delay1() {
  unsigned char data  i,k;
  for (i=0;i<D1;i++) {
      for (k=0;k<D1;k++); 
  }
}
